/**
 * @license
 * MIT License
 * 
 * Copyright (c) 2014-present, Lee Byron and other contributors.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).Immutable={})}(this,(function(t){"use strict";function e(t,e){if("number"!=typeof e){var o=e>>>0;if(""+o!==e||4294967295===o)return NaN;e=o}return e<0?function(t){return void 0===t.size&&(t.size=t.__iterate(r)),t.size}(t)+e:e}function r(){return!0}var o="@@__IMMUTABLE_ITERABLE__@@";function n(t){return Boolean(t&&t[o])}var i="@@__IMMUTABLE_KEYED__@@";function u(t){return Boolean(t&&t[i])}var c="@@__IMMUTABLE_INDEXED__@@";function p(t){return Boolean(t&&t[c])}function f(t){return u(t)||p(t)}var a=function(t){return n(t)?t:T(t)},_=function(t){function e(t){return u(t)?t:M(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(a),y=function(t){function e(t){return p(t)?t:k(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(a),s=function(t){function e(t){return n(t)&&!f(t)?t:B(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(a);a.Keyed=_,a.Indexed=y,a.Set=s;var h="@@__IMMUTABLE_SEQ__@@";var l="@@__IMMUTABLE_RECORD__@@";function v(t){return Boolean(t&&t[l])}function b(t){return n(t)||v(t)}var d="function"==typeof Symbol&&Symbol.iterator,S="@@iterator",j=d||S,g=function(t){this.next=t};function E(t,e,r,o){var n=0===t?e:1===t?r:[e,r];return o?o.value=n:o={value:n,done:!1},o}function O(){return{value:void 0,done:!0}}function w(t){return!!Array.isArray(t)||!!I(t)}function q(t){return t&&"function"==typeof t.next}function m(t){var e=I(t);return e&&e.call(t)}function I(t){var e=t&&(d&&t[d]||t[S]);if("function"==typeof e)return e}g.prototype.toString=function(){return"[Iterator]"},g.KEYS=0,g.VALUES=1,g.ENTRIES=2,g.prototype.inspect=g.prototype.toSource=function(){return this.toString()},g.prototype[j]=function(){return this};var A=Object.prototype.hasOwnProperty;function x(t){return!(!Array.isArray(t)&&"string"!=typeof t)||t&&"object"==typeof t&&Number.isInteger(t.length)&&t.length>=0&&(0===t.length?1===Object.keys(t).length:t.hasOwnProperty(t.length-1))}var T=function(t){function e(t){return null==t?P():b(t)?t.toSeq():function(t){var e=D(t);if(e)return(o=I(r=t))&&o===r.entries?e.fromEntrySeq():function(t){var e=I(t);return e&&e===t.keys}(t)?e.toSetSeq():e;var r,o;if("object"==typeof t)return new L(t);throw new TypeError("Expected Array or collection object of values, or keyed object: "+t)}(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.toSeq=function(){return this},e.prototype.toString=function(){return this.__toString("Seq {","}")},e.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},e.prototype.__iterate=function(t,e){var r=this._cache;if(r){for(var o=r.length,n=0;n!==o;){var i=r[e?o-++n:n++];if(!1===t(i[1],i[0],this))break}return n}return this.__iterateUncached(t,e)},e.prototype.__iterator=function(t,e){var r=this._cache;if(r){var o=r.length,n=0;return new g((function(){if(n===o)return{value:void 0,done:!0};var i=r[e?o-++n:n++];return E(t,i[0],i[1])}))}return this.__iteratorUncached(t,e)},e}(a),M=function(t){function e(t){return null==t?P().toKeyedSeq():n(t)?u(t)?t.toSeq():t.fromEntrySeq():v(t)?t.toSeq():function(t){var e=D(t);if(e)return e.fromEntrySeq();if("object"==typeof t)return new L(t);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+t)}(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.toKeyedSeq=function(){return this},e}(T),k=function(t){function e(t){return null==t?P():n(t)?u(t)?t.entrySeq():t.toIndexedSeq():v(t)?t.toSeq().entrySeq():function(t){var e=D(t);if(e)return e;throw new TypeError("Expected Array or collection object of values: "+t)}(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return e(arguments)},e.prototype.toIndexedSeq=function(){return this},e.prototype.toString=function(){return this.__toString("Seq [","]")},e}(T),B=function(t){function e(t){return(n(t)&&!f(t)?t:k(t)).toSetSeq()}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return e(arguments)},e.prototype.toSetSeq=function(){return this},e}(T);T.isSeq=function(t){return Boolean(t&&t[h])},T.Keyed=M,T.Set=B,T.Indexed=k,T.prototype[h]=!0;var U=function(t){function r(t){this._array=t,this.size=t.length}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.get=function(t,r){return this.has(t)?this._array[e(this,t)]:r},r.prototype.__iterate=function(t,e){for(var r=this._array,o=r.length,n=0;n!==o;){var i=e?o-++n:n++;if(!1===t(r[i],i,this))break}return n},r.prototype.__iterator=function(t,e){var r=this._array,o=r.length,n=0;return new g((function(){if(n===o)return{value:void 0,done:!0};var i=e?o-++n:n++;return E(t,i,r[i])}))},r}(k),L=function(t){function e(t){var e=Object.keys(t).concat(Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(t):[]);this._object=t,this._keys=e,this.size=e.length}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.get=function(t,e){return void 0===e||this.has(t)?this._object[t]:e},e.prototype.has=function(t){return A.call(this._object,t)},e.prototype.__iterate=function(t,e){for(var r=this._object,o=this._keys,n=o.length,i=0;i!==n;){var u=o[e?n-++i:i++];if(!1===t(r[u],u,this))break}return i},e.prototype.__iterator=function(t,e){var r=this._object,o=this._keys,n=o.length,i=0;return new g((function(){if(i===n)return{value:void 0,done:!0};var u=o[e?n-++i:i++];return E(t,u,r[u])}))},e}(M);L.prototype["@@__IMMUTABLE_ORDERED__@@"]=!0;var R,z=function(t){function e(t){this._collection=t,this.size=t.length||t.size}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.__iterateUncached=function(t,e){if(e)return this.cacheResult().__iterate(t,e);var r=m(this._collection),o=0;if(q(r))for(var n;!(n=r.next()).done&&!1!==t(n.value,o++,this););return o},e.prototype.__iteratorUncached=function(t,e){if(e)return this.cacheResult().__iterator(t,e);var r=m(this._collection);if(!q(r))return new g(O);var o=0;return new g((function(){var e=r.next();return e.done?e:E(t,o++,e.value)}))},e}(k);function P(){return R||(R=new U([]))}function D(t){return x(t)?new U(t):w(t)?new z(t):void 0}var K=Object.prototype.toString;function N(t,e,r,o,n,i){if("string"!=typeof r&&!b(r)&&(x(r)||w(r)||function(t){if(!t||"object"!=typeof t||"[object Object]"!==K.call(t))return!1;var e=Object.getPrototypeOf(t);if(null===e)return!0;for(var r=e,o=Object.getPrototypeOf(e);null!==o;)r=o,o=Object.getPrototypeOf(r);return r===e}(r))){if(~t.indexOf(r))throw new TypeError("Cannot convert circular structure to Immutable");t.push(r),n&&""!==o&&n.push(o);var u=e.call(i,o,T(r).map((function(o,i){return N(t,e,o,i,n,r)})),n&&n.slice());return t.pop(),n&&n.pop(),u}return r}function C(t,e){return p(e)?e.toList():u(e)?e.toMap():e.toSet()}t.fromJS=function(t,e){return N([],e||C,t,"",e&&e.length>2?[]:void 0,{"":t})}}));
